package com.ym.mec.biz.service.impl;


import static com.ym.mec.biz.dal.enums.GroupType.GOODS_SELL;
import static com.ym.mec.biz.dal.enums.GroupType.MUSIC;
import static com.ym.mec.biz.dal.enums.OrderDetailTypeEnum.*;
import static com.ym.mec.biz.dal.enums.OrderDetailTypeEnum.ORGAN_SHARE_PROFIT;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.*;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Supplier;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSON;
import com.ym.mec.biz.dal.dto.ComplementGoodsDto;
import com.ym.mec.biz.dal.entity.*;
import com.ym.mec.biz.dal.mapper.GoodsSubMapper;
import com.ym.mec.biz.service.*;
import com.ym.mec.common.api.CommonResult;
import com.ym.mec.common.dto.OrderCreate;
import com.ym.mec.common.dto.PmsProductDto;
import com.ym.mec.common.dto.PmsProductQueryParamDto;
import com.ym.mec.common.dto.ReturnApplyDto;
import com.ym.mec.common.exception.BizException;
import com.ym.mec.common.page.PageInfo;
import com.ym.mec.common.page.WrapperUtil;
import com.ym.mec.mall.MallFeignService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import com.ym.mec.biz.dal.dao.GoodsDao;
import com.ym.mec.biz.dal.dao.MusicGroupDao;
import com.ym.mec.biz.dal.dao.SellOrderDao;
import com.ym.mec.biz.dal.dao.SporadicChargeInfoDao;
import com.ym.mec.biz.dal.dao.StudentPaymentOrderDao;
import com.ym.mec.biz.dal.dao.StudentPaymentOrderDetailDao;
import com.ym.mec.biz.dal.dao.StudentRepairDao;
import com.ym.mec.biz.dal.enums.AccountType;
import com.ym.mec.biz.dal.enums.GoodsType;
import com.ym.mec.biz.dal.enums.KitGroupPurchaseTypeEnum;
import com.ym.mec.biz.dal.enums.OrderDetailTypeEnum;
import com.ym.mec.biz.dal.enums.OrderTypeEnum;
import com.ym.mec.biz.dal.enums.PaymentChannelEnum;
import com.ym.mec.biz.dal.enums.ReturnFeeEnum;
import com.ym.mec.biz.dal.enums.SellStatus;
import com.ym.mec.biz.dal.enums.SellTypeEnum;
import com.ym.mec.biz.dal.enums.SporadicChargeTypeEnum;
import com.ym.mec.common.dal.BaseDAO;
import com.ym.mec.common.service.impl.BaseServiceImpl;

@Service
public class SellOrderServiceImpl extends BaseServiceImpl<Integer, SellOrder> implements SellOrderService {
    @Autowired
    private SellOrderDao sellOrderDao;
    @Autowired
    private GoodsDao goodsDao;
    @Autowired
    private StudentPaymentOrderDao studentPaymentOrderDao;
    @Autowired
    private MusicGroupDao musicGroupDao;
    @Autowired
    private SysPaymentConfigService sysPaymentConfigService;
    @Autowired
    private SysUserCashAccountLogService sysUserCashAccountLogService;
    @Autowired
    private GoodsService goodsService;
    @Autowired
    private StudentPaymentOrderDetailDao studentPaymentOrderDetailDao;
    @Autowired
    private SporadicChargeInfoDao sporadicChargeInfoDao;
    @Autowired
    private StudentPaymentOrderDetailService studentPaymentOrderDetailService;
    @Autowired
    private GoodsSubService goodsSubService;
    @Autowired
    private MallFeignService mallFeignService;

    @Override
    public BaseDAO<Integer, SellOrder> getDAO() {
        return sellOrderDao;
    }


 /*   @Override
    @Transactional(rollbackFor = Exception.class, isolation = Isolation.READ_COMMITTED)
    public List<SellOrder> addSellOrder(Long orderId, String musicGroupId, List<Integer> goodsIds, BigDecimal totalAmount, BigDecimal balance, BigDecimal couponRemitFee) {
        if (goodsIds == null || goodsIds.size() <= 0) {
            return null;
        }
        if (balance == null) {
            balance = BigDecimal.ZERO;
        }
        StudentPaymentOrder order = studentPaymentOrderDao.get(orderId);
        BigDecimal totalActualAmount = order.getActualAmount() == null ? BigDecimal.ZERO : order.getActualAmount();
        MusicGroup musicGroup = new MusicGroup();
        if (StringUtils.isNotBlank(musicGroupId)) {
            musicGroup = musicGroupDao.get(musicGroupId);
        }
        int goodsNum = goodsIds.size();
        BigDecimal goodsTotalPrice = BigDecimal.ZERO;
        List<Goods> goodies = goodsDao.getGoodies(goodsIds);
        int i = 1;
        for (Integer goodsId : goodsIds) {
            for (Goods goods : goodies) {
                if (goods.getId().equals(goodsId)) {
                    goodsTotalPrice = goodsTotalPrice.add(goods.getDiscountPrice());
                    break;
                }
            }
        }
        //商品总价值去掉优惠券减免
//        if(goodsTotalPrice.compareTo(couponRemitFee) <= 0){
//            goodsTotalPrice = BigDecimal.ZERO;
//        }else {
//            goodsTotalPrice = goodsTotalPrice.subtract(couponRemitFee);
//        }

        //已分配的商品余额
        BigDecimal hasRouteBalance = BigDecimal.ZERO;
        //已分配的商品现金
        BigDecimal hasRouteActualAmount = BigDecimal.ZERO;
        //商品占用的的余额
        BigDecimal goodsTotalBalance = totalAmount.compareTo(BigDecimal.ZERO) <= 0 ? BigDecimal.ZERO : goodsTotalPrice.multiply(balance).divide(totalAmount, 2, BigDecimal.ROUND_DOWN);
        //商品占用的总现金
        BigDecimal goodsTotalActualAmount = totalAmount.compareTo(BigDecimal.ZERO) <= 0 ? BigDecimal.ZERO : goodsTotalPrice.multiply(totalActualAmount).divide(totalAmount, 2, BigDecimal.ROUND_DOWN);
        AccountType accountType = sysPaymentConfigService.checkAccountType(PaymentChannelEnum.valueOf(order.getPaymentChannel()), order.getMerNos(), order.getTenantId());

        List<SellOrder> sellOrderList = goodsService.subtractStock(goodsIds, accountType);
        BigDecimal freeCouponRemitFee = couponRemitFee;
        for (int j = 0; j < goodsIds.size(); j++) {
            Integer goodsId = goodsIds.get(j);
            BigDecimal goodsPrice = BigDecimal.ZERO;
            Goods nowGoods = new Goods();
            for (Goods goods : goodies) {
                if (goods.getId().equals(goodsId)) {
                    nowGoods = goods;
                    break;
                }
            }
            goodsPrice = nowGoods.getDiscountPrice();
            //扣除减免金额
//            if(couponRemitFee.compareTo(BigDecimal.ZERO) > 0){
//                if(j == goodsIds.size() - 1){
//                    goodsPrice = goodsPrice.subtract(freeCouponRemitFee);
//                }else {
//                    //获取比例
//                    BigDecimal divide = goodsPrice.divide(goodsPrice.add(couponRemitFee), 6, BigDecimal.ROUND_HALF_UP);
//                    //分摊金额
//                    BigDecimal scale = couponRemitFee.multiply(divide).setScale(2, BigDecimal.ROUND_HALF_UP);
//                    freeCouponRemitFee = freeCouponRemitFee.subtract(scale);
//                    goodsPrice = goodsPrice.subtract(scale);
//                }
//            }

            //当前商品占用的总优惠券减免
            BigDecimal couponBalance = goodsTotalPrice.compareTo(BigDecimal.ZERO) <= 0 ? BigDecimal.ZERO :
                    couponRemitFee.multiply(goodsPrice).divide(goodsTotalPrice, 2, BigDecimal.ROUND_DOWN);
            //当前商品占用的总余额
            BigDecimal goodsBalance = goodsTotalPrice.compareTo(BigDecimal.ZERO) <= 0 ? BigDecimal.ZERO :
                    goodsTotalBalance.multiply(goodsPrice).divide(goodsTotalPrice, 2, BigDecimal.ROUND_DOWN);
            //当前商品占用的总现金
            BigDecimal goodsActualAmount = goodsTotalPrice.compareTo(BigDecimal.ZERO) <= 0 ? BigDecimal.ZERO :
                    goodsTotalActualAmount.multiply(goodsPrice).divide(goodsTotalPrice, 2, BigDecimal.ROUND_DOWN);

            if (i == goodsNum) {
                couponBalance = couponRemitFee.subtract(freeCouponRemitFee);
                goodsBalance = goodsTotalBalance.subtract(hasRouteBalance);
                goodsActualAmount = goodsTotalActualAmount.subtract(hasRouteActualAmount);
            }
            freeCouponRemitFee = freeCouponRemitFee.subtract(couponBalance);
            hasRouteBalance = hasRouteBalance.add(goodsBalance);
            hasRouteActualAmount = hasRouteActualAmount.add(goodsActualAmount);
            i++;

            int complementGoodsNum = nowGoods.getComplementGoodsIdList() == null ? 1 : nowGoods.getComplementGoodsIdList().split(",").length;
            BigDecimal complementPrice = nowGoods.getDiscountPrice();
            Map<Integer, BigDecimal> complementGoodsPrice = new HashMap<>();
            complementGoodsPrice.put(nowGoods.getId(), nowGoods.getDiscountPrice());
            if (nowGoods.getComplementGoodsIdList() != null) {
                List<Goods> complementGoodies = goodsDao.findGoodsByIds(nowGoods.getComplementGoodsIdList());
                complementGoodsPrice = complementGoodies.stream().collect(Collectors.toMap(Goods::getId, Goods::getDiscountPrice));
                complementPrice = complementGoodies.stream().map(Goods::getDiscountPrice).reduce(BigDecimal.ZERO, BigDecimal::add);
            }

            BigDecimal hasRouteSellOrderActualAmount = BigDecimal.ZERO;
            BigDecimal hasRouteSellOrderBalance = BigDecimal.ZERO;
            BigDecimal hasRouteCouponBalance = BigDecimal.ZERO;
            for (SellOrder sellOrder : sellOrderList) {
                if (!goodsId.equals(sellOrder.getParentGoodsId()) && !goodsId.equals(sellOrder.getGoodsId())) {
                    continue;
                }
                if (sellOrder.getHasRoute()) {
                    continue;
                }
                BigDecimal sellOrderActualAmount = BigDecimal.ZERO;
                BigDecimal sellOrderBalance = BigDecimal.ZERO;
                if (complementPrice.compareTo(BigDecimal.ZERO) > 0) {
                    sellOrderActualAmount = complementGoodsPrice.get(sellOrder.getGoodsId()).multiply(new BigDecimal(sellOrder.getNum())).multiply(goodsActualAmount).divide(complementPrice, 2, BigDecimal.ROUND_DOWN);
                    sellOrderBalance = complementGoodsPrice.get(sellOrder.getGoodsId()).multiply(new BigDecimal(sellOrder.getNum())).multiply(goodsBalance).divide(complementPrice, 2, BigDecimal.ROUND_DOWN);
                }

                complementGoodsNum = complementGoodsNum - sellOrder.getNum();
                if (complementGoodsNum <= 0) {
                    sellOrderActualAmount = goodsActualAmount.subtract(hasRouteSellOrderActualAmount);
                    sellOrderBalance = goodsBalance.subtract(hasRouteSellOrderBalance);
                }
                hasRouteSellOrderActualAmount = hasRouteSellOrderActualAmount.add(sellOrderActualAmount);
                hasRouteSellOrderBalance = hasRouteSellOrderBalance.add(sellOrderBalance);

                sellOrder.setExpectAmount(sellOrderActualAmount.add(sellOrderBalance));
                sellOrder.setBalanceAmount(sellOrderBalance);
//                sellOrder.setCouponRemitAmount(sellOrderCouponBalance);
                sellOrder.setActualAmount(sellOrderActualAmount);
                sellOrder.setOrganId(order.getOrganId());
                sellOrder.setCooperationOrganId(musicGroup.getCooperationOrganId());
                sellOrder.setTransNo(order.getTransNo());
                sellOrder.setOrderId(order.getId());
                sellOrder.setOrderNo(order.getOrderNo());
                sellOrder.setUserId(order.getUserId());
                sellOrder.setPaymentChannel(order.getPaymentChannel());
                sellOrder.setMerNo(order.getMerNos());
                sellOrder.setSellTime(order.getCreateTime());
                sellOrder.setCreateIme(new Date());
                sellOrder.setUpdateTime(new Date());
                if (nowGoods.getType().equals(GoodsType.INSTRUMENT)) {
                    sellOrder.setType(SellTypeEnum.INSTRUMENT);
                } else if (nowGoods.getType().equals(GoodsType.ACCESSORIES)) {
                    sellOrder.setType(SellTypeEnum.ACCESSORIES);
                } else {
                    sellOrder.setType(SellTypeEnum.OTHER);
                }
                sellOrder.setHasRoute(true);
                if (complementGoodsNum <= 0) {
                    break;
                }
            }
        }
        if (sellOrderList.size() > 0) {
            //如果有优惠券金额
            if (couponRemitFee.compareTo(BigDecimal.ZERO) > 0) {
                BigDecimal reduce = sellOrderList.stream().map(e -> e.getExpectAmount()).reduce(BigDecimal.ZERO, BigDecimal::add);
                List<SellOrder> sellOrders = sellOrderList.stream().filter(e -> e.getExpectAmount().compareTo(BigDecimal.ZERO) > 0).collect(Collectors.toList());
                //可用优惠券金额
                BigDecimal subCouponMarketAmount = couponRemitFee;
                for (int j = 0; j < sellOrders.size(); j++) {
                    SellOrder sellOrder = sellOrders.get(j);
                    //如果是最后一件商品
                    if (j == sellOrders.size() - 1) {
                        sellOrder.setCouponRemitAmount(subCouponMarketAmount);
                    } else {
                        //获取比例
                        BigDecimal ratioAmount = sellOrder.getExpectAmount().divide(reduce, 6, BigDecimal.ROUND_HALF_UP);
                        //获取分配的减免金额
                        BigDecimal multiply = couponRemitFee.multiply(ratioAmount).setScale(2, BigDecimal.ROUND_HALF_UP);
                        subCouponMarketAmount = subCouponMarketAmount.subtract(multiply);
                        sellOrder.setCouponRemitAmount(multiply);
                    }
                }
            }
            sellOrderDao.batchInsert(sellOrderList);
        }
        return sellOrderList;
    }
*/
    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<SellOrder> addOrderDetail2SellOrder(List<StudentPaymentOrderDetail> orderDetails,
                                                    StudentPaymentOrder studentPaymentOrder, MusicGroup musicGroup,BigDecimal balancePaymentAmount) {
        //过去非商品详情
        List<StudentPaymentOrderDetail> goodsOrderDetails = orderDetails.stream().filter(e -> StringUtils.isNotEmpty(e.getGoodsIdList())).collect(Collectors.toList());
        if(CollectionUtils.isEmpty(goodsOrderDetails)){
            throw new BizException("商品详情为空");
        }
        //获取总减免金额
        BigDecimal detailTotalRemitPrice = goodsOrderDetails.stream().map(StudentPaymentOrderDetail::getRemitFee).reduce(BigDecimal.ZERO, BigDecimal::add);
        //获取总金额
        BigDecimal detailTotalPrice = goodsOrderDetails.stream().map(StudentPaymentOrderDetail::getPrice).reduce(BigDecimal.ZERO, BigDecimal::add);

        List<SellOrder> sellOrders = new ArrayList<>();

        //剩余待分配的余额
        BigDecimal subDetailBalance = balancePaymentAmount;
        //剩余待分配的优惠券金额
        BigDecimal subDetailCouponRemitFee = detailTotalRemitPrice;
        //剩余待分配现金
        BigDecimal subDetailActualAmount = detailTotalPrice.subtract(balancePaymentAmount);
        for (int i = 0; i < goodsOrderDetails.size(); i++) {
            StudentPaymentOrderDetail orderDetail = goodsOrderDetails.get(i);
            //获取支付金额比例
            BigDecimal ratioAmount = BigDecimal.ZERO;
            if(detailTotalPrice.compareTo(BigDecimal.ZERO) > 0){
                ratioAmount = orderDetail.getPrice().divide(detailTotalPrice, 6, BigDecimal.ROUND_HALF_UP);
            }
            BigDecimal ratioCouponAmount = BigDecimal.ZERO;
            if (detailTotalRemitPrice.compareTo(BigDecimal.ZERO) > 0) {
                //获取优惠券金额比例
                ratioCouponAmount = orderDetail.getRemitFee().divide(detailTotalRemitPrice, 6, BigDecimal.ROUND_HALF_UP);
            }
            //获取分配的余额
            BigDecimal detailBalance;
            //获取分配的优惠券金额
            BigDecimal couponRemitFee;
            //获取剩余待分配的现金
            BigDecimal detailActualAmount;
            if (i == goodsOrderDetails.size() - 1) {
                //获取分配的余额
                detailBalance = subDetailBalance;
                //获取分配的优惠券金额
                couponRemitFee = subDetailCouponRemitFee;
                //获取剩余待分配的现金
                detailActualAmount = subDetailActualAmount;
            } else {
                //获取分配的余额
                detailBalance = balancePaymentAmount.multiply(ratioAmount).setScale(2, BigDecimal.ROUND_DOWN);
                subDetailBalance = subDetailBalance.subtract(detailBalance);
                //获取分配的优惠券金额
                couponRemitFee = orderDetail.getRemitFee().multiply(ratioCouponAmount).setScale(2, BigDecimal.ROUND_HALF_UP);
                subDetailCouponRemitFee = subDetailCouponRemitFee.subtract(couponRemitFee);
                //获取剩余待分配的现金
                detailActualAmount = orderDetail.getPrice().subtract(detailBalance);
                subDetailActualAmount = subDetailActualAmount.subtract(detailActualAmount);
            }
            List<Integer> goodsIds = Arrays.asList(orderDetail.getGoodsIdList().split(",")).stream().map(Integer::parseInt).collect(Collectors.toList());
            sellOrders.addAll(this.initSellOrder(studentPaymentOrder, musicGroup.getId(), goodsIds, orderDetail.getKitGroupPurchaseType(),
                    detailBalance, orderDetail.getPrice(), couponRemitFee, detailActualAmount, false));
        }

/*
            BigDecimal goodsTotalPrice = orderDetail.getGoodsList().stream().map(Goods::getGroupPurchasePrice).reduce(BigDecimal.ZERO, BigDecimal::add);
            BigDecimal routePrice = BigDecimal.ZERO;
            BigDecimal routeBalance = BigDecimal.ZERO;
            int j = 1;

            List<Integer> goodsIds = orderDetail.getGoodsList().stream().map(Goods::getId).collect(Collectors.toList());
            List<SellOrder> sellOrderList = goodsService.subtractStock(goodsIds, accountType);
            for (Goods goods : orderDetail.getGoodsList()) {
                BigDecimal expectAmount = BigDecimal.ZERO;
                BigDecimal balance = BigDecimal.ZERO;
                if (goodsTotalPrice.compareTo(BigDecimal.ZERO) > 0) {
                    expectAmount = goods.getGroupPurchasePrice().multiply(orderDetail.getPrice()).divide(goodsTotalPrice, 2, BigDecimal.ROUND_DOWN);
                    balance = goods.getGroupPurchasePrice().multiply(detailBalance).divide(goodsTotalPrice, 2, BigDecimal.ROUND_DOWN);
                }
                if (j == orderDetail.getGoodsList().size()) {
                    expectAmount = orderDetail.getPrice().subtract(routePrice);
                    balance = detailBalance.subtract(routeBalance);
                }
                routePrice = routePrice.add(expectAmount);
                routeBalance = routeBalance.add(balance);
                j++;

                int complementGoodsNum = goods.getComplementGoodsIdList() == null ? 1 : goods.getComplementGoodsIdList().split(",").length;
                BigDecimal complementPrice = goods.getGroupPurchasePrice();
                Map<Integer, BigDecimal> complementGoodsPrice = new HashMap<>();
                complementGoodsPrice.put(goods.getId(), goods.getGroupPurchasePrice());
                if (goods.getComplementGoodsIdList() != null) {
                    List<Goods> complementGoodies = goodsDao.findGoodsByIds(goods.getComplementGoodsIdList());
                    complementGoodsPrice = complementGoodies.stream().collect(Collectors.toMap(Goods::getId, Goods::getGroupPurchasePrice));
                    complementPrice = complementGoodies.stream().map(Goods::getGroupPurchasePrice).reduce(BigDecimal.ZERO, BigDecimal::add);
                }

                BigDecimal hasRouteSellOrderExpectAmount = BigDecimal.ZERO;
                BigDecimal hasRouteSellOrderBalance = BigDecimal.ZERO;
                for (SellOrder sellOrder : sellOrderList) {
                    if (!goods.getId().equals(sellOrder.getParentGoodsId()) && !goods.getId().equals(sellOrder.getGoodsId())) {
                        continue;
                    }
                    if (sellOrder.getHasRoute()) {
                        continue;
                    }
                    sellOrder.setTenantId(tenantId);
                    BigDecimal sellOrderExpectAmount = BigDecimal.ZERO;
                    BigDecimal sellOrderBalance = BigDecimal.ZERO;
                    if (complementPrice.compareTo(BigDecimal.ZERO) > 0) {
                        sellOrderExpectAmount = complementGoodsPrice.get(sellOrder.getGoodsId()).multiply(new BigDecimal(sellOrder.getNum())).multiply(expectAmount).divide(complementPrice, 2, BigDecimal.ROUND_DOWN);
                        sellOrderBalance = complementGoodsPrice.get(sellOrder.getGoodsId()).multiply(new BigDecimal(sellOrder.getNum())).multiply(balance).divide(complementPrice, 2, BigDecimal.ROUND_DOWN);
                    }
                    complementGoodsNum = complementGoodsNum - sellOrder.getNum();
                    if (complementGoodsNum <= 0) {
                        sellOrderExpectAmount = expectAmount.subtract(hasRouteSellOrderExpectAmount);
                        sellOrderBalance = balance.subtract(hasRouteSellOrderBalance);
                    }
                    hasRouteSellOrderExpectAmount = hasRouteSellOrderExpectAmount.add(sellOrderExpectAmount);
                    hasRouteSellOrderBalance = hasRouteSellOrderBalance.add(sellOrderBalance);

                    sellOrder.setOrganId(studentPaymentOrder.getOrganId());
                    sellOrder.setTransNo(studentPaymentOrder.getTransNo());
                    sellOrder.setOrderId(studentPaymentOrder.getId());
                    if (musicGroup != null) {
                        sellOrder.setCooperationOrganId(musicGroup.getCooperationOrganId());
                        sellOrder.setEduTeacherId(musicGroup.getEducationalTeacherId());
                    }
                    sellOrder.setOrderNo(studentPaymentOrder.getOrderNo());
                    sellOrder.setActualAmount(sellOrderExpectAmount.subtract(sellOrderBalance));
                    sellOrder.setBalanceAmount(sellOrderBalance);
                    sellOrder.setExpectAmount(sellOrderExpectAmount);
//                    sellOrder.setCouponRemitAmount(goods.getGroupPurchasePrice().subtract(sellOrderExpectAmount));
                    sellOrder.setNum(1);
                    sellOrder.setUserId(studentPaymentOrder.getUserId());
                    sellOrder.setPaymentChannel(studentPaymentOrder.getPaymentChannel());
                    sellOrder.setMerNo(studentPaymentOrder.getMerNos());
                    sellOrder.setSellTime(studentPaymentOrder.getCreateTime());
                    sellOrder.setCreateIme(new Date());
                    sellOrder.setUpdateTime(new Date());
                    if (goods.getType().equals(GoodsType.INSTRUMENT)) {
                        sellOrder.setType(SellTypeEnum.INSTRUMENT);
                    } else if (goods.getType().equals(GoodsType.ACCESSORIES)) {
                        sellOrder.setType(SellTypeEnum.ACCESSORIES);
                    } else {
                        sellOrder.setType(SellTypeEnum.OTHER);
                    }
                    //租赁、免费的没有销售收入，有销售成本
                    if (orderDetail.getType().equals(OrderDetailTypeEnum.MUSICAL) &&
                            (orderDetail.getKitGroupPurchaseType().equals(KitGroupPurchaseTypeEnum.LEASE) ||
                                    orderDetail.getKitGroupPurchaseType().equals(KitGroupPurchaseTypeEnum.FREE)
                            )) {
                        sellOrder.setActualAmount(BigDecimal.ZERO);
                        sellOrder.setBalanceAmount(BigDecimal.ZERO);
                        sellOrder.setExpectAmount(BigDecimal.ZERO);
                    }
                    sellOrder.setHasRoute(true);
                    if (complementGoodsNum <= 0) {
                        break;
                    }
                }

            }
            sellOrders.addAll(sellOrderList);
        }
        if (sellOrders.size() > 0) {
            //如果有优惠券金额
            if (musicRemitFee.compareTo(BigDecimal.ZERO) > 0) {
                BigDecimal reduce = sellOrders.stream().map(e -> e.getExpectAmount()).reduce(BigDecimal.ZERO, BigDecimal::add);
                List<SellOrder> sellOrderList = sellOrders.stream().filter(e -> e.getExpectAmount().compareTo(BigDecimal.ZERO) > 0).collect(Collectors.toList());
                //可用优惠券金额
                BigDecimal subCouponMarketAmount = musicRemitFee;
                for (int j = 0; j < sellOrderList.size(); j++) {
                    SellOrder sellOrder = sellOrderList.get(j);
                    //如果是最后一件商品
                    if (j == sellOrderList.size() - 1) {
                        sellOrder.setCouponRemitAmount(subCouponMarketAmount);
                    } else {
                        //获取比例
                        BigDecimal ratioAmount = sellOrder.getExpectAmount().divide(reduce, 6, BigDecimal.ROUND_HALF_UP);
                        //获取分配的减免金额
                        BigDecimal multiply = musicRemitFee.multiply(ratioAmount).setScale(2, BigDecimal.ROUND_HALF_UP);
                        subCouponMarketAmount = subCouponMarketAmount.subtract(multiply);
                        sellOrder.setCouponRemitAmount(multiply);
                    }
                }
            }
            sellOrderDao.batchInsert(sellOrders);
        }*/
        return sellOrders;
    }

    @Override
    public void batchInsert(List<SellOrder> sellOrders) {
        sellOrderDao.batchInsert(sellOrders);
    }

    @Override
    public List<SellOrder> getSellOrderByParentGoodsId(Long orderId, Integer parentGoodsId) {
        return sellOrderDao.getSellOrderByParentGoodsId(orderId, parentGoodsId);
    }

    @Override
    @Transactional(rollbackFor = Exception.class, isolation = Isolation.READ_COMMITTED)
    public List<SellOrder> refund(List<SellOrder> sellOrders, Boolean reBackFee) {
        Date nowDate = new Date();
        for (SellOrder sellOrder : sellOrders) {
            //1、更改销售列表状态
            sellOrder.setStatus(SellStatus.REFUND);
            sellOrder.setUpdateTime(nowDate);
            sellOrder.setRefundTime(nowDate);
            sellOrderDao.update(sellOrder);

            //2、金额退到余额
            if (reBackFee && sellOrder.getExpectAmount().compareTo(BigDecimal.ZERO) > 0) {
                SysUserCashAccountLog sysUserCashAccountLog = new SysUserCashAccountLog();
                sysUserCashAccountLog.setReturnFeeType(ReturnFeeEnum.GOODS);
                sysUserCashAccountLog.setOrganId(sellOrder.getOrganId());
                sysUserCashAccountLog.setUserId(sellOrder.getUserId());
                sysUserCashAccountLog.setGroupType(GOODS_SELL);
                sysUserCashAccountLog.setComment("商品退费");
                sysUserCashAccountLog.setGroupId(sellOrder.getId().toString());
                sysUserCashAccountLog.setAmount(sysUserCashAccountLogService.musicReturnFeeCharges(sellOrder.getExpectAmount(),0));
                sysUserCashAccountLogService.insert(sysUserCashAccountLog);
//                sysUserCashAccountService.updateBalance(sellOrder.getUserId(), sellOrder.getExpectAmount().multiply(new BigDecimal(0.995)).setScale(CommonConstants.DECIMAL_FINAL_PLACE, BigDecimal.ROUND_HALF_UP), PlatformCashAccountDetailTypeEnum.REFUNDS, "订单：" + sellOrder.getOrderId() + " 商品id：" + sellOrder.getGoodsId() + "退货");
            }
        }
        //3、退货
        /*if (sellOrders.get(0).getAccountType() != null) {
            goodsService.increaseStock(sellOrders, sellOrders.get(0).getAccountType());
        }*/
        //4退货同步到商城
        this.mallRefundByOrderId(sellOrders);
        return sellOrders;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<SellOrder> refundByOrderId(Long orderId, Boolean reBackFee) {
        List<SellOrder> sellOrders = sellOrderDao.getSellOrderByParentGoodsId(orderId, null);
        if (sellOrders.size() <= 0) {
            return sellOrders;
        }
        return refund(sellOrders, reBackFee);
    }

    @Override
    public List<SellOrder> getRefundSellOrder(List<Long> orderIdList) {
        return sellOrderDao.getRefundSellOrder(orderIdList);
    }

    @Override
    public Map<String, BigDecimal> getSellAmount(String orderNo) {
        StudentPaymentOrder order = studentPaymentOrderDao.findOrderByOrderNo(orderNo);
        if (order == null) {
            return null;
        }
        
        List<StudentPaymentOrderDetail> studentPaymentOrderDetailList = studentPaymentOrderDetailService.queryOrderDetail(order.getId());
        BigDecimal cloudIncome = BigDecimal.ZERO;
        BigDecimal cloudBalanceIncome = BigDecimal.ZERO;
        if(studentPaymentOrderDetailList != null) {
        	cloudIncome = studentPaymentOrderDetailList.stream().filter(t -> StringUtils.isNoneBlank(t.getMinuendStockGoodsIdList()) && StringUtils.equals(t.getIncomeItem(), OrderDetailTypeEnum.CLOUD_TEACHER.name())).map(t -> t.getIncome()).reduce(BigDecimal.ZERO, BigDecimal::add);
        	cloudBalanceIncome = studentPaymentOrderDetailList.stream().filter(t -> StringUtils.isNoneBlank(t.getMinuendStockGoodsIdList()) && StringUtils.equals(t.getIncomeItem(), OrderDetailTypeEnum.CLOUD_TEACHER.name())).map(t -> t.getBalanceIncome()).reduce(BigDecimal.ZERO, BigDecimal::add);
        }

        //零星支付除了充值其他都是服务费用
        if (order.getType().equals(OrderTypeEnum.SPORADIC)) {
            SporadicChargeInfo info = sporadicChargeInfoDao.get(Integer.parseInt(order.getMusicGroupId()));
            if (info.getChargeType().equals(SporadicChargeTypeEnum.RECHARGE)) {
                return null;
            }
        }
        Map<String, BigDecimal> sellAmount = new HashMap<>();
        //乐器销售,声部更改,乐器置换
        if (order.getType().equals(OrderTypeEnum.GOODS_SELL) || order.getType().equals(OrderTypeEnum.SUBJECT_CHANGE) || order.getType().equals(OrderTypeEnum.REPLACEMENT)) {
            sellAmount.put("actualAmount", order.getActualAmount().subtract(cloudIncome));
            sellAmount.put("balance", order.getBalancePaymentAmount() == null ? BigDecimal.ZERO : order.getBalancePaymentAmount().subtract(cloudBalanceIncome));
            return sellAmount;
        }
        //乐团报名,乐器维修
        if (order.getType().equals(OrderTypeEnum.APPLY) || order.getType().equals(OrderTypeEnum.REPAIR)) {
            return this.calcSellAmount(order,cloudBalanceIncome, cloudIncome);
        }
        sellAmount.put("actualAmount", BigDecimal.ZERO);
        sellAmount.put("balance", BigDecimal.ZERO);
        return sellAmount;
    }

    @Override
    public List<OrderCreate.OrderItem> convertMallOrder(List<SellOrder> sellOrderList) {
        List<OrderCreate.OrderItem> orderItems = new ArrayList<>();
        for (SellOrder e : sellOrderList) {
            List<GoodsSub> list = goodsSubService.lambdaQuery().eq(GoodsSub::getGoodsId, e.getParentGoodsId()).list();
            if(CollectionUtils.isEmpty(list)){
                throw new RuntimeException("子商品不存在，请联系管理员");
            }
            BigDecimal totalPrice = e.getExpectAmount().divide(new BigDecimal(e.getNum()), 2, RoundingMode.HALF_UP);
            //总金额按比例分配
            //待分配
            BigDecimal waitRemitFee = totalPrice;
            BigDecimal totalAmount = WrapperUtil.sumList(list, GoodsSub::getGoodsPrice);
            for (int i = 0; i < list.size(); i++) {
                GoodsSub goodsDto = list.get(i);
                OrderCreate.OrderItem orderItemCreate = new OrderCreate.OrderItem();
                orderItemCreate.setProductQuantity(e.getNum());
                orderItemCreate.setProductSkuId(goodsDto.getSku().longValue());
                //如果是最后一件商品
                if (i == list.size() - 1) {
                    orderItemCreate.setRealAmount(waitRemitFee);
                } else {
                    //获取比例
                    BigDecimal ratioAmount = goodsDto.getGoodsPrice().divide(totalAmount, 6, RoundingMode.HALF_UP);
                    //获取分配的金额
                    BigDecimal multiply = ratioAmount.multiply(totalPrice).setScale(2, RoundingMode.HALF_UP);
                    orderItemCreate.setRealAmount(multiply);
                    waitRemitFee = waitRemitFee.subtract(multiply);
                }
                orderItems.add(orderItemCreate);
            }
        }
        return orderItems;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void syncSellOrder2Mall(List<SellOrder> sellOrders, StudentPaymentOrder studentPaymentOrder) {
        List<OrderCreate.OrderItem> orderItems = this.convertMallOrder(sellOrders);
        OrderCreate mallOrder = new OrderCreate();
        mallOrder.setOrderItemList(orderItems);
        mallOrder.setOrchestraId(studentPaymentOrder.getMusicGroupId());
        mallOrder.setStatus(1);
        mallOrder.setOrderNo(studentPaymentOrder.getOrderNo());
        mallOrder.setTotalAmount(studentPaymentOrder.getExpectAmount());
        String paymentBusinessChannel = studentPaymentOrder.getPaymentBusinessChannel();
        if (StringUtils.endsWithIgnoreCase(paymentBusinessChannel, "wx_pub") ||
                StringUtils.endsWithIgnoreCase(paymentBusinessChannel, "WECHAT") ||
                StringUtils.endsWithIgnoreCase(paymentBusinessChannel, "WXPay")) {
            mallOrder.setPayType(2);
        } else {
            mallOrder.setPayType(1);
        }
        mallOrder.setMemberId(studentPaymentOrder.getUserId().longValue());
        mallOrder.setPlatformType("STUDENT");
        mallOrder.setSourceType(1);

        CommonResult<Boolean> result = mallFeignService.productOrderCreate(mallOrder);
        if (result.getCode() != 200) {
            throw new BizException("同步商城订单失败",result.getMessage());
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void mallRefundByOrderId(List<SellOrder> sellOrders) {
        String skuIds = sellOrders.stream().map(e -> e.getGoodsSkuId().toString()).collect(Collectors.joining(","));
        ReturnApplyDto returnApply = new ReturnApplyDto();
        returnApply.setOrderSn(sellOrders.get(0).getOrderNo());
        returnApply.setReason("管乐迷商品更换退货");
        returnApply.setSkuIds(skuIds);
        CommonResult<Boolean> result = mallFeignService.returnApply(returnApply);
        if (result.getCode() != 200){
            throw new BizException("商城订单退货失败",result.getMessage());
        }
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<SellOrder> initSellOrder(StudentPaymentOrder order, String musicGroupId, List<Integer> goodsIds, KitGroupPurchaseTypeEnum kitGroupPurchaseType,
                                         BigDecimal totalBalance, BigDecimal expectTotalAmount, BigDecimal couponRemitAmount,
                                         BigDecimal actualTotalAmount, Boolean saveFlag) {
        //可用优惠券金额
        BigDecimal subCouponRemitAmount = couponRemitAmount;
        //可用总金额
        BigDecimal subExpectTotalAmount = expectTotalAmount;
        //可用总余额
        BigDecimal subTotalBalance = totalBalance;
        //实际金额
        BigDecimal subTotalActualAmount = actualTotalAmount;
        Integer tenantId = order.getTenantId();
        MusicGroup musicGroup = new MusicGroup();
        if (StringUtils.isNotBlank(musicGroupId)) {
            musicGroup = musicGroupDao.get(musicGroupId);
        }
        List<Goods> goodies = goodsDao.getGoodies(goodsIds);
        BigDecimal goodsTotalPrice = goodies.stream().map(Goods::getGroupPurchasePrice).reduce(BigDecimal.ZERO, BigDecimal::add);

        AccountType accountType = sysPaymentConfigService.checkAccountType(PaymentChannelEnum.valueOf(order.getPaymentChannel()), order.getMerNos(), order.getTenantId());
        PmsProductQueryParamDto paramDto = new PmsProductQueryParamDto();
        String skuIds = goodsSubService.lambdaQuery().in(GoodsSub::getGoodsId, goodies.stream().map(Goods::getId).collect(Collectors.toList())).list()
                .stream().map(e->e.getSku().toString()).collect(Collectors.joining(","));
        paramDto.setSkuStockIds(skuIds);
        paramDto.setPageSize(1000);
        paramDto.setPageNum(1);
        paramDto.setJson(JSON.toJSONString(paramDto));
        PageInfo<PmsProductDto> productList = mallFeignService.getProductList(paramDto);
        if (org.springframework.util.CollectionUtils.isEmpty(productList.getRows())) {
            throw new BizException("商城商品不存在");
        }
        Map<Integer,PmsProductDto> skuIdProductMap = productList.getRows().stream().collect(Collectors.toMap(PmsProductDto::getSkuStockId, Function.identity()));
        List<SellOrder> sellOrderList = new ArrayList<>();
        for (int i = 0; i < goodies.size(); i++) {
            Goods nowGoods = goodies.get(i);
            //获取比例
            BigDecimal goodsRatioAmount = BigDecimal.ZERO;
            //预计金额
            BigDecimal expectAmount;
            //余额
            BigDecimal goodsBalance;
            //减免金额
            BigDecimal remitAmount;
            //实际金额
            BigDecimal actualAmount;

            if (goodsTotalPrice.compareTo(BigDecimal.ZERO) > 0) {
                goodsRatioAmount = order.getGroupType() == MUSIC ?nowGoods.getGroupPurchasePrice():nowGoods.getDiscountPrice()
                        .divide(goodsTotalPrice, 6, RoundingMode.HALF_UP);
            }
            if(i == goodies.size() - 1){
                expectAmount = subExpectTotalAmount;
                goodsBalance = subTotalBalance;
                remitAmount = subCouponRemitAmount;
                actualAmount = subTotalActualAmount;
            }else {
                expectAmount = goodsRatioAmount.multiply(expectTotalAmount).setScale(2, RoundingMode.HALF_UP);
                subExpectTotalAmount = subExpectTotalAmount.subtract(expectAmount);
                goodsBalance = goodsRatioAmount.multiply(totalBalance).setScale(2, RoundingMode.HALF_UP);
                subTotalBalance = subTotalBalance.subtract(goodsBalance);
                remitAmount = goodsRatioAmount.multiply(couponRemitAmount).setScale(2, RoundingMode.HALF_UP);
                subCouponRemitAmount = subCouponRemitAmount.subtract(remitAmount);
                actualAmount = expectAmount.subtract(goodsBalance).subtract(remitAmount);
                subTotalActualAmount = subTotalActualAmount.subtract(actualAmount);
            }
            //剩余预计金额
            BigDecimal subExpectAmount = expectAmount;
            //剩余余额
            BigDecimal subGoodsBalance = goodsBalance;
            //剩余减免金额
            BigDecimal subRemitAmount = remitAmount;
            //剩余实际金额
            BigDecimal subActualAmount = actualAmount;
            //租赁、免费的没有销售收入，有销售成本
            if (nowGoods.getType().equals(GoodsType.INSTRUMENT) && kitGroupPurchaseType != null &&
                    (kitGroupPurchaseType.equals(KitGroupPurchaseTypeEnum.LEASE) || kitGroupPurchaseType.equals(KitGroupPurchaseTypeEnum.FREE))) {
                goodsBalance = BigDecimal.ZERO;
                expectAmount = BigDecimal.ZERO;
            }

            List<GoodsSub> goodsSubs = goodsSubService.lambdaQuery().eq(GoodsSub::getGoodsId, nowGoods.getId()).list();
            //商品原始总价
            BigDecimal complementPrice = goodsSubs.stream().map(GoodsSub::getGoodsPrice).reduce(BigDecimal.ZERO, BigDecimal::add);
            //生成sellOrder
            for (int j = 0; j < goodsSubs.size(); j++) {
                GoodsSub goodsSub = goodsSubs.get(j);
                PmsProductDto productDto = skuIdProductMap.get(goodsSub.getSku());
                if(Objects.isNull(productDto)){
                    throw new BizException("商品["+nowGoods.getName()+"]子商品["+goodsSub.getSku()+"]不存在");
                }
                SellOrder sellOrder = new SellOrder();
                //获取比例
                BigDecimal ratioAmount = goodsSub.getGoodsPrice().divide(complementPrice, 6, RoundingMode.HALF_UP);
                if (j == goodsSubs.size() - 1){
                    sellOrder.setExpectAmount(subExpectAmount);
                    sellOrder.setBalanceAmount(subGoodsBalance);
                    sellOrder.setActualAmount(subActualAmount);
                    sellOrder.setCouponRemitAmount(subRemitAmount);
                }else {
                    BigDecimal decimal = expectAmount.multiply(ratioAmount).setScale(2, RoundingMode.HALF_UP);
                    sellOrder.setExpectAmount(decimal);
                    subExpectAmount = subExpectAmount.subtract(decimal);
                    BigDecimal balance = goodsBalance.multiply(ratioAmount).setScale(2, RoundingMode.HALF_UP);
                    sellOrder.setBalanceAmount(balance);
                    subGoodsBalance = subGoodsBalance.add(balance);
                    BigDecimal actual = actualAmount.multiply(ratioAmount).setScale(2, RoundingMode.HALF_UP);
                    sellOrder.setActualAmount(actual);
                    subActualAmount = subActualAmount.subtract(actual);
                    BigDecimal remit = remitAmount.multiply(ratioAmount).setScale(2, RoundingMode.HALF_UP);
                    sellOrder.setCouponRemitAmount(remit);
                    subRemitAmount = subRemitAmount.subtract(remit);
                }
                sellOrder.setParentGoodsId(nowGoods.getId());
                sellOrder.setGoodsSkuId(goodsSub.getSku());
                sellOrder.setNum(1);
                sellOrder.setGoodsName(productDto.getName());
                sellOrder.setAccountType(accountType);
                sellOrder.setOrganSellCost(goodsSub.getGoodsPrice());
                sellOrder.setOrganId(order.getOrganId());
                sellOrder.setCooperationOrganId(musicGroup.getCooperationOrganId());
                sellOrder.setEduTeacherId(musicGroup.getEducationalTeacherId());
                sellOrder.setTransNo(order.getTransNo());
                sellOrder.setOrderId(order.getId());
                sellOrder.setOrderNo(order.getOrderNo());
                sellOrder.setUserId(order.getUserId());
                sellOrder.setPaymentChannel(order.getPaymentChannel());
                sellOrder.setMerNo(order.getMerNos());
                sellOrder.setSellTime(order.getCreateTime());
                sellOrder.setTenantId(tenantId);
                if (nowGoods.getType().equals(GoodsType.INSTRUMENT)) {
                    sellOrder.setType(SellTypeEnum.INSTRUMENT);
                } else if (nowGoods.getType().equals(GoodsType.ACCESSORIES)) {
                    sellOrder.setType(SellTypeEnum.ACCESSORIES);
                } else {
                    sellOrder.setType(SellTypeEnum.OTHER);
                }
                sellOrderList.add(sellOrder);
            }
        }
        if (saveFlag && !org.springframework.util.CollectionUtils.isEmpty(sellOrderList)) {
            this.batchInsert(sellOrderList);
            this.syncSellOrder2Mall(sellOrderList,order);
        }
        return sellOrderList;
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public List<SellOrder> initSellOrder(StudentPaymentOrder order, String musicGroupId, List<Integer> goodsIds,
                                         KitGroupPurchaseTypeEnum kitGroupPurchaseType,Boolean saveFlag) {
        BigDecimal totalBalance = order.getBalancePaymentAmount();
        if (totalBalance == null) {
            totalBalance = BigDecimal.ZERO;
        }
        BigDecimal expectTotalAmount = order.getExpectAmount();
        BigDecimal couponRemitAmount = order.getCouponRemitFee();
        BigDecimal actualTotalAmount = order.getActualAmount();
        return this.initSellOrder(order, musicGroupId, goodsIds, kitGroupPurchaseType, totalBalance, expectTotalAmount,
                couponRemitAmount, actualTotalAmount,saveFlag==null?true:saveFlag);
    }

    public Map<String, BigDecimal> calcSellAmount(StudentPaymentOrder order,BigDecimal cloudBalanceIncome,BigDecimal cloudIncome) {
        List<StudentPaymentOrderDetail> orderDetails = studentPaymentOrderDetailDao.getOrderDetail(order.getId());
        //总余额支付
        BigDecimal totalBalance = order.getBalancePaymentAmount() != null ? order.getBalancePaymentAmount() : BigDecimal.ZERO;
        //总价格
        BigDecimal totalPrice = order.getExpectAmount();
        //商品总付款
        BigDecimal detailTotalPrice = orderDetails.stream().map(StudentPaymentOrderDetail::getPrice).reduce(BigDecimal.ZERO, BigDecimal::add);
        //商品销售占的余额
        BigDecimal detailTotalBalance = detailTotalPrice.multiply(totalBalance).divide(totalPrice, 2, BigDecimal.ROUND_DOWN);

        if(detailTotalBalance.subtract(cloudBalanceIncome).compareTo(BigDecimal.ZERO) < 0) {
            detailTotalBalance = cloudBalanceIncome;
        }

        BigDecimal actualAmount = detailTotalPrice.multiply(order.getActualAmount()).divide(totalPrice, 2, BigDecimal.ROUND_DOWN);

        if(actualAmount.subtract(cloudIncome).compareTo(BigDecimal.ZERO) < 0){
            actualAmount = cloudIncome;
        }
        Map<String, BigDecimal> sellAmount = new HashMap<>(2);
        //返回销售收入
        sellAmount.put("actualAmount", actualAmount.subtract(cloudIncome));
        sellAmount.put("balance", detailTotalBalance.subtract(cloudBalanceIncome));
        return sellAmount;
    }

}
